// Base Linear Array
// developped by denpaware 1999.  
// last update 5/29
//1z̊{NX@ev[gNX

#ifndef CBASELINEARARRAY_INCL
#define CBASELINEARARRAY_INCL

#include <stdio.h>
#include <stdlib.h>

#include "LARExcept.h"
#include "windows.h"

#define _FILE_ "basearray.h"
#define _LINE_ -1



template <class T> class CBaseLinearArray
{
	
private:
	void IsValid()
	{
		if( signature != SIGNATURE ){
			throw CLArrayExcept(CLArrayExcept::INVALID_OBJ,_FILE_ , _LINE_  , 
				instanceName  , CLArrayExcept::NO_POS , length); 
		}
	}


public:
	enum LINEAR_ARRAY_SIGNATURE {
		SIGNATURE = 254874572,
		NOT_VALID = 0,
		VALID = 1
	};
	
	CBaseLinearArray(int size = 1, char* name = "default")
	{
		pData = new T[size];
		if( pData == NULL ){ 
			throw CLArrayExcept(CLArrayExcept::MALLOC_FAILED,_FILE_ , _LINE_  , 
				instanceName, CLArrayExcept::NO_POS , length); 
		}
		length = size;
		signature = SIGNATURE;
		strcpy(instanceName , name);
	}
	CBaseLinearArray(int size ,  T& init , char* name ="default"  )
	{
		try{
			CBaseLinearArray(size );
		}
		catch(CBaseException e){
			throw e;
		}
		ResetElements(init);
		signature = SIGNATURE;
		strcpy(instanceName , name);
	}
	virtual ~CBaseLinearArray(){ 
		signature = NOT_VALID;
		delete pData; 
	}
	//Rs[RXgN^
	CBaseLinearArray(CBaseLinearArray& a)
	{
		IsValid();
		a.pData = new T[length];
		if(a.pData == NULL ){ 
				throw CLArrayExcept(CLArrayExcept::MALLOC_FAILED,_FILE_ , _LINE_  , 
					instanceName , CLArrayExcept::NO_POS , length); 
		}
		memcpy(a.pData , pData , length * sizeof(T));
		strcpy(a.instanceName , instanceName);
		strcpy(a.filename , filename);
		a.length = length;
		a.signature = signature;
	}
	//
	void GetBlock(int start,int size,T* pDat)
	{
		IsValid();	
		if( start < 0 || start >= length || size < 0 || (start+size) < 0 || (start+size) >= length){
			throw CLArrayExcept(CLArrayExcept::INVALID_POS,_FILE_ , _LINE_  , 
				instanceName , pos , length); 
		}
		int i,j;
		for( i = start , j = 0; j < size ; i++ , j++){
			*(pDat + j) = *(pData + i);
		}
	}
	void SetBlock(int start,int size,T* pDat)
	{
		IsValid();	
		if( start < 0 || start >= length || size < 0 || (start+size) < 0 || (start+size) >= length){
			throw CLArrayExcept(CLArrayExcept::INVALID_POS,_FILE_ , _LINE_  , 
				instanceName , pos , length); 
		}
		int i,j;
		for( i = start , j = 0; j < size ; i++ , j++){
			 *(pData + i) = *(pDat + j);
		}
	}
	inline void GetElement(int pos , T& dat)
	{
		IsValid();
		if( pos < 0 || pos >= length ){
			throw CLArrayExcept(CLArrayExcept::INVALID_POS,_FILE_ , _LINE_  , 
				instanceName  , pos , length); 
		}
		dat = *(pData + pos);
	}
	inline void SetElement(int pos,T& dat)
	{
		IsValid();
		if( pos < 0 || pos >= length ){
			throw CLArrayExcept(CLArrayExcept::INVALID_POS , _FILE_ , _LINE_  , 
				instanceName  , pos , length); 
		}
		*(pData + pos) = dat;
	}
	void BinSave(CBaseLinearArray<T>* a ,char* f)
	{
		a->IsValid();	
		
		unsigned char *buf;
		int len;
		a->OnSetElementToBuffer(&buf,&len);
		FILE* fp = fopen(f , "wb");
		if( 1 != fwrite(buf , len , 1 , fp) ){
			fclose(fp);
			throw CLArrayExcept(CLArrayExcept::FILE_SAVE_FAILED , _FILE_ , _LINE_  , 
				a->instanceName  ,CLArrayExcept::NO_POS , a->length); 
		}
		fclose(fp);
	
		delete buf;
	}
	void BinLoad(CBaseLinearArray<T>* a ,char* f)
	{
		a->IsValid();	
		int len;
		len = a->OnGetFileLength(f );
			
		char *buf = new char[len];
		FILE* fp = fopen(f , "rb");
		if( 1 != fread(buf , len , 1 , fp) ){
			fclose(fp);
			throw CLArrayExcept(CLArrayExcept::FILE_LOAD_FAILED , _FILE_ , _LINE_  , 
				a->instanceName  , CLArrayExcept::NO_POS , a->length); 
		}
		fclose(fp);
		a->OnSetElementFromBuffer(buf , len);
		delete buf;
	}
	//nˑ
	void TextSave(CBaseLinearArray<T>* a ,char* f)
	{
		a->IsValid();	
		
		unsigned char *buf;
		int len;
		a->OnSetElementToBuffer(&buf,&len);
		FILE* fp = fopen(f , "wt");
		if( 1 != fwrite(buf , len , 1 , fp) ){
			fclose(fp);
			//0̂Ƃ͗O𔭐Ȃ
			if( len != 0 ){
				throw CLArrayExcept(CLArrayExcept::FILE_SAVE_FAILED , _FILE_ , _LINE_  , 
					a->instanceName  ,CLArrayExcept::NO_POS , a->length); 
			}
		}
		fclose(fp);
		delete buf;
	}
	//nˑ
	void TextLoad(CBaseLinearArray<T>* a ,char* f)
	{
		a->IsValid();	
		int len;
		len = a->OnGetFileLength(f );
			
		char *buf = new char[len+1]; //ŌNULLmۗp+1
		memset(buf , NULL , len+1); //kŏ
		FILE* fp = fopen(f , "rt");
		if( fp == NULL ){
			throw CLArrayExcept(CLArrayExcept::FILE_LOAD_FAILED , _FILE_ , _LINE_  , 
				a->instanceName  , CLArrayExcept::NO_POS , a->length); 
		}
		fread(buf , len , 1 , fp); //textmodeł̓t@Cǂ݂݃oCgȂꍇiCR-LFϊj
		fclose(fp);
		a->OnSetElementFromBuffer(buf , len);
		delete buf;
	}
	void Resize(int size)
	{
		IsValid();
		T* pOldData = pData;
		pData = new T[size];
		if( pData == NULL ){ 
			throw CLArrayExcept(CLArrayExcept::MALLOC_FAILED,_FILE_ , _LINE_  , 
				instanceName, CLArrayExcept::NO_POS , length); 
		}
		int i;
		if( length < size ){
			for( i =  0 ;  i < length ; i++){
				*(pData+i) = *(pOldData + i);
			}
		}else{
			for( i =  0 ;  i < size ; i++){
				*(pData+i) = *(pOldData + i);
			}

		}
		delete pOldData;
		length = size;
	}
	void ResetElements(T& dat)
	{
		IsValid();
		int i;
		for( i = 0 ; i < 0 ; i++){
			*(pData + i) = dat;
		}
	}
	inline int GetSizeInElement(void){IsValid(); return (length);}
	inline int GetSIzeInByte(void){IsValid(); return ((length) * sizeof(T)); }
	void AddElement(T& d)
	{
		IsValid();
		Resize(length+1);
		SetElement( length-1 , d);	
	}
	void DeleteElement(int pos)
	{
		IsValid();
		if( pos < 0 || pos >= length ){
			throw CLArrayExcept(CLArrayExcept::INVALID_POS , _FILE_ , _LINE_  , 
				instanceName  , pos , length); 
		}
		int i;
		for( i = pos ; i < length -1; i++){
			*(pData + i) = *(pData+ i + 1);
		}
		Resize(length-1);
	}
	void SetInstanceName(char* n)
	{
		if( strlen(n) >= _MAX_PATH ){
			throw CLArrayExcept(CLArrayExcept::TOOLONG_INSTNAME , _FILE_ , _LINE_  , 
				instanceName  , CLArrayExcept::NO_POS , length); 
		}
		strcpy(instanceName , n);
	}
	//O_MAX_PATHȏ̃ɊmۂĂ
	void GetInstanceName(char *n)
	{
		strcpy( n , instanceName);
	}
protected:
	//nˑ
	int OnGetFileLength(char* f)
	{
		IsValid();
		HANDLE hf;
		SECURITY_ATTRIBUTES sa;
		sa.nLength = sizeof(SECURITY_ATTRIBUTES);
		sa.lpSecurityDescriptor = NULL;
		sa.bInheritHandle = TRUE;		

		hf = CreateFile(f ,GENERIC_READ, 0 , &sa , OPEN_EXISTING , FILE_ATTRIBUTE_NORMAL , 0);
		if( hf == INVALID_HANDLE_VALUE ){
			throw CLArrayExcept(CLArrayExcept::GET_FILE_LENGTH_FAILED,_FILE_ , _LINE_  , 
					instanceName , CLArrayExcept::NO_POS , length); 
		}
		int l = GetFileSize(hf , NULL);
		CloseHandle(hf); //file close
		return l;

	}
	//t@C[h̃ftHg
	//T\̂̂Ƃ̂ݗL
	//vflengthݒ肷Kv
	virtual void OnSetElementFromBuffer(char *buf ,int len) 
	{
		IsValid();
		unsigned int i;// size_t ƔrƂ̃[jOoȂ߂unsigned
		Resize(len/sizeof(T));
		for( i = 0 ; i < len/sizeof(T) ; i++){
			memcpy( (pData + i) , buf + i*sizeof(T) , sizeof(T) );
		}
	}

	//t@CZ[ũftHg
	//T\̂̂Ƃ̂ݗL
	//bufւ͎̃OŊm
	virtual void OnSetElementToBuffer(unsigned char** buf, int* len)
	{
		IsValid();
		int i;
		*buf = new unsigned char[length*sizeof(T)]; 
		for( i = 0 ; i < length ; i++){
			memcpy( (pData + i) , *buf + i*sizeof(T) , sizeof(T) );
		}
		*len = sizeof(T) * length;
	}

	T* pData;
	char filename[_MAX_PATH];
	//CX^X̖O@OɃX[
	char instanceName[_MAX_PATH];
	//vf
	int length; //0IWł͂ȂB
 	//tB[h
	int signature;
};

#endif

